/* 
 This file was generated by Dashcode.  
 You may edit this file to customize your widget or web page 
 according to the license.txt file included in the project.
 */

/*
Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
	•	Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
	•	Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
	•	Neither the name of Nick Zitzmann nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

window.onfocus = function ()
{
	if (window.dashcode)	// don't do this on Windows because it interferes with the pop-up menu
	{
	    document.getElementById("search").focus();	// make the search input field the first responder when our window becomes key
	}
}


//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
	if (window.dashcode)
	{
		dashcode.setupParts();
	}
	self.sync();
}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // Stop any timers to prevent CPU usage
    // Remove any preferences as needed
    // widget.setPreferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
	widget.setPreferenceForKey(null, dashcode.createInstancePreferenceKey("SearchEngine"));
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    // Stop any timers to prevent CPU usage
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
    // Restart any timers that were stopped on hide
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
    // Retrieve any preference values that you need to be synchronized here
    // Use this for an instance key's value:
    // instancePreferenceValue = widget.preferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
    //
    // Or this for global key's value:
	// globalPreferenceValue = widget.preferenceForKey(null, "your-key");
	var popup = document.getElementById("popup");
	var searchEngine;

	if (window.widget)
	{
		searchEngine = widget.preferenceForKey(dashcode.createInstancePreferenceKey("SearchEngine"));
	}
	else if (System.Gadget)
	{
		searchEngine = System.Gadget.Settings.readString("SearchEngine");
	}

	if (searchEngine)
	{
		popup.value = searchEngine;
	}
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}


function keydown(event)
{
	if (event.keyCode == 13)
	{
		var searchField = document.getElementById('search');
		var searchString = searchField.value;
		var popup = document.getElementById('popup');
		var engine = popup.value;
		
		if (searchString.length > 0)
		{
			var searchURL;
			
			searchString = encodeURIComponent(searchString);
			switch (engine)
			{
				case 'adc':
					searchURL = "https://developer.apple.com/search.php?Search=" + searchString;
					break;
				case 'altavista':
					searchURL = "http://www.altavista.com/web/results?q=" + searchString;
					break;
				case 'amazon':
					searchURL = "https://www.amazon.com/s/ref=nb_sb_noss?url=search-alias%3Daps&field-keywords=" + searchString;
					break;
				case 'ask':
					searchURL = "http://www.ask.com/web?q=" + searchString;
					break;
				case 'bing':
					searchURL = "https://www.bing.com/search?q=" + searchString;
					break;
				case 'ebay':
					searchURL = "http://shop.ebay.com/i.html?_nkw=" + searchString;
					break;
				case 'facebook':
					searchURL = "https://www.facebook.com/search/?q=" + searchString;
					break;
				case 'goog':
					searchURL = "https://www.google.com/search?q=" + searchString;
					break;
				case 'ixquick':
					searchURL = "https://www.ixquick.com/do/metasearch.pl?query=" + searchString;
					break;
				case 'msdn':
					searchURL = "http://social.msdn.microsoft.com/search/en-us/?query=" + searchString;
					break;
				case 'twitter':
					searchURL = "https://twitter.com/search?q=" + searchString;
					break;
				case 'wikipedia':
					searchURL = "https://secure.wikimedia.org/wikipedia/en/w/index.php?title=Special%3ASearch&search=" + searchString;
					break;
				case 'wiktionary':
					searchURL = "https://secure.wikimedia.org/wiktionary/en/wiki/Special:Search?search=" + searchString + "&go=Define";
					break;
				case 'alpha':
					searchURL = "http://www.wolframalpha.com/input/?i=" + searchString;
					break;
				case 'yahoo':
					searchURL = "http://search.yahoo.com/search?p=" + searchString;
					break;
				case 'youtube':
					searchURL = "http://www.youtube.com/results?search_query=" + searchString;
					break;
				default:
					searchURL = "https://duckduckgo.com/?q=" + searchString + "&v=";
					break;
			}

			if (window.widget)	// Mac OS X
			{
			    widget.openURL(searchURL);
			}
			else if (System.Shell)	// Windows
			{
			    System.Shell.execute(searchURL);
			}
			searchField.value = "";	// clear the field after searching
		}
	}
}


function engineSelected(event)
{
	var searchField = document.getElementById("search");
	var popup = document.getElementById("popup");
	
	searchField.focus(); // after choosing an engine, make the search field first responder
	
	// Save the selected search engine for later use:
	if (window.widget)	// Mac OS X
	{
		widget.setPreferenceForKey(popup.value, dashcode.createInstancePreferenceKey("SearchEngine"));
	}
	else if (System.Gadget)	// Windows
	{
		System.Gadget.Settings.writeString("SearchEngine", popup.value);
	}
}


function goHome(event)
{
	widget.openURL("http://seiryu.home.comcast.net/");
}
